; *******************************************************************
; *                                                                 *
; *                          scribble.asm                           *
; *                                                                 *
; *   This aplet is based on Darrin Massena's PILA sample code.     *
; *   It requires Darrin's PILOT.INC and STARTUP.INC include files. *
; *   For info on how to write apps for the world's best palmtop,   *
; *   aim your browser at                                           *
; *   http://www.massena.com/darrin/pilot                           *
; *                                                                 *
; *   If you have any questions about this source code,             *
; *   please send them to howlett@iosphere.net                      *
; *                                                                 *
; *   This code is freeware and you are free to modify it as you    *
; *   wish, however you must register your own Creator ID before    *
; *   you distribute any modifications.                             *
; *                                                                 *
; *                                                                 *
; *   Andrew Howlett                                                *
; *   howlett@iosphere.net                                          *
; *   13 Dec 96                                                     *
; *                                                                 *
; *******************************************************************

        Appl    "Scribble", 'Scrb'                      ; define name and creator ID
                                                        ; creator type is #$53637262

        include "Pilot.inc"                             ; structs, constants
        include "Startup.inc"                           ; common startup code

kidbAIB         equ             $7FFE                   ; Application-defined resource ids
kidrPREF        equ             1                       ; don't know who made up these names
kidrTVER        equ             1
kidrTAIB        equ             1000
kidfMain        equ             1000

kidmMain        equ             1000
kidmClear       equ             1001
kidmAbout       equ             1002
kidrAboutAlert  equ             1000
kidcEvent       equ             1005                    ; debug code
ScribbleAppType equ             $53637262               ; 'Scrb'
ScribbleDatabaseType  equ       $44617461               ; 'Data'

        data                                            ; global variables
global lastX.w                                          ; globals are offsets from a5
global lastY.w
global lastX1.w
global lastY1.w
global SkipFirstEvent.w
;global ErrorString.10                                  ; debug variables
;global gpfieldEvent.12                                 ; debug variables
;global strDisplay.12                                   ; debug variables

        code

; *******************************************************************
; *                                                                 *
; *   DWord PilotMain(Word cmd, void *cmdPBP, Word launchflags)     *
; *                                                                 *
; *   PilotMain is called by the startup code and implements        *
; *   a simple event handling loop.                                 *
; *                                                                 *
; *******************************************************************

proc PilotMain(cmd.w, cmdPBP.l, launchFlags.w)
local   err.w
local   evt.EventType

beginproc
        tst.w   cmd(a6)                                 ;sysAppLaunchCmdNormalLaunch is 0
        bne     PmReturn                                ;not a normal launch, bag out

        systrap FrmGotoForm(#kidfMain.w)

PmEventLoop                                             ; Doze until an event arrives
        systrap EvtGetEvent(&evt(a6), #evtWaitForever.w)


        systrap SysHandleEvent(&evt(a6))                ; First handler is system
        tst.b   d0                                      ; handled?
        bne.s   PmEventDone                             ; yep

                                                        ; Second is menu handler
        systrap MenuHandleEvent(&0, &evt(a6), &err(a6))
        tst.b   d0                                      ; handled?
        bne.s   PmEventDone                             ; yep

                                                        ; Third is application handler
        call    ApplicationHandleEvent(&evt(a6))
        tst.b   d0                                      ; handled?
        bne.s   PmEventDone                             ; yep

                                                        ; Fourth is form handler.
                                                        ; Form handler is where our
                                                        ; custom code is located
        call    MainFormHandleEvent(&evt(a6))
        tst.b   d0                                      ; handled?
        bne.s   PmEventDone                             ; yep

                                                        ; Still not handled.
                                                        ; We're not interested
                                                        ; in it anymore so let the                                          
        systrap FrmGetActiveForm()                      ; default form handler take it.
        systrap FrmHandleEvent(a0.l, &evt(a6))


                                                        ; Return from PilotMain when an
PmEventDone                                             ; appStopEvent is received
        cmpi.w  #appStopEvent,evt+EventType.eType(a6)   ; time to stop?
        bne.s   PmEventLoop                             ; nope, loop until it is

PmReturn
        moveq   #0, d0
endproc


; *******************************************************************
; *                                                                 *
; *   Boolean ApplicationHandleEvent(EventType *pevt)               *
; *                                                                 *
; *   Handles these events:    frmLoadEvent                         *
; *                                                                 *
; *******************************************************************

proc ApplicationHandleEvent(pevt.l)
local Rectangle.RectangleType
local Error.w
beginproc
        movem.l a3,-(a7)                                ;save registers we're going to trash
        movem.l a4,-(a7)
        movem.l d1,-(a7)

        movea.l pevt(a6),a0                             ;a0 = pevt

                                                        ; Handle frmLoadEvent
        cmp.w   #frmLoadEvent,EventType.eType(a0) 
        beq     FormLoadHandler
        cmpi.w  #appStopEvent,EventType.eType(a0) 
        beq     ApplicationStopHandler
        bra     ApplicationEventNotHandled

FormLoadHandler                                         ; Initialize the form and make it active
        systrap FrmInitForm(EventType.data+frmLoad.formID(a0).w)
        move.l  a0,a3                                   ; save a copy of FormPtr for later

        systrap FrmSetActiveForm(a0.l)

;        systrap FrmGetObjectIndex(a3.l, #kidcEvent.w)   ; debug code
;        systrap FrmGetObjectPtr(a3.l,d0.w)              ; debug code
;        move.l  a0, gpfieldEvent(a5)                    ; debug code

;        move.b  #69,    ErrorString(a5)                 ; debug code
;        move.b  #114, 1+ErrorString(a5)                 ; debug code
;        move.b  #114, 2+ErrorString(a5)                 ; debug code
;        move.b  #111, 3+ErrorString(a5)                 ; debug code
;        move.b  #114, 4+ErrorString(a5)                 ; debug code
;        move.b  #0,   5+ErrorString(a5)                 ; debug code
                                                        
        systrap FrmGetActiveForm()                      ; Draw the form
        systrap FrmDrawForm(a0.l)
        movea.l #$00006518, a3                          ; Restore previous image
        systrap PrefGetAppPreferences(#ScribbleAppType.l, #1.w, a3, #2840.w)
        bra     ApplicationEventNotHandled

ApplicationStopHandler                                  ; Application Stop Handler
        movea.l #$00006518, a3                          ; save the current image
        systrap PrefSetAppPreferences(#ScribbleAppType.l, #1.w, a3, #2840.w)

ApplicationEventNotHandled
        clr.b   d0

ApplicationEventReturn
        movem.l (a7)+,d1
        movem.l (a7)+,a4
        movem.l (a7)+,a3
endproc


; *******************************************************************
; *                                                                 *
; *   Boolean MainFormHandleEvent(EventType *pevt)                  *
; *                                                                 *
; *   Handles these events:    frmOpenEvent                         *
; *                            frmMenuEvent                         *
; *                            penDownEvent                         *
; *                                                                 *
; *******************************************************************

proc MainFormHandleEvent(pevt.l)

local   strDisplay.12

beginproc

        movea.l pevt(a6),a0                             ;  a0 = pevt
        move.w  EventType.eType(a0),d0                  ;  d0 = event type

        cmp.w   #frmOpenEvent,d0                        ; Handle frmOpenEvent
        bne     MenuHandler

;        systrap FrmGetActiveForm()                     ; Draw the form
;        systrap FrmDrawForm(a0.l)
;
;  Special note:  I moved the form drawing code into FormLoadHandler
;                 because otherwise FrmDrawForm would overwrite the
;                 restored image.

        moveq.l #1,d0
        bra     MFHReturn

MenuHandler
        cmp.w   #menuEvent,d0                           ; Handle frmMenuEvent
        bne     PenHandler
                                                        ; Show "About" info box
        cmp.w   #kidmAbout, EventType.data+menu.itemID(a0)
        beq     MenuAboutHandler
        cmp.w   #kidmClear, EventType.data+menu.itemID(a0)
        beq     MenuClearHandler
        bra     MFHNotHandled

MenuAboutHandler
        systrap FrmAlert(#kidrAboutAlert.w)
        moveq.l #1,d0
        bra     MFHReturn

MenuClearHandler                                        ; Clear menu chosen
        systrap WinEraseWindow()                        ; Erase the window
        systrap FrmGetActiveForm()                      ; Get form point a0
        systrap FrmDrawForm(a0.l)                       ; Draw the form
        moveq.l #1,d0
        bra     MFHReturn

PenHandler
        cmp.w   #penDownEvent, d0                       ; Handle penDownEvent
        beq     PenDownEventHandler
        cmp.w   #penUpEvent, d0                         ; Handle penUpEvent
        beq     PenEventHandler
        cmp.w   #penMoveEvent, d0                       ; Handle penMoveEvent
        beq     PenEventHandler
        bra     KeyboardHandler

PenDownEventHandler
        move.w EventType.screenX(a0), lastX(a5)         ; move x into lastX
        move.w EventType.screenY(a0), lastY(a5)         ; move y into lastY
        move.w #48, SkipFirstEvent(a5)
        bra     MFHReturn

PenEventHandler
        cmp     #48, SkipFirstEvent(a5)                 ; skip first event
        bne     MFHReturn
        cmp.w   #penUpEvent, d0
        bne     DrawLineHandler
        move.w  #00, SkipFirstEvent(a5)

DrawLineHandler
        clr.l d1
        clr.l d2
        move.w EventType.screenX(a0), d1                ; move x into d1
        move.w EventType.screenY(a0), d2                ; move y into d2
        move.w d1, lastX1(a5)
        move.w d2, lastY1(a5)

        systrap WinDrawLine(lastX(a5).w, lastY(a5).w, d1.w, d2.w)

        move.w lastX1(a5), lastX(a5)
        move.w lastY1(a5), lastY(a5)

        bra     MFHReturn

KeyboardHandler
        cmp.w   #keyDownEvent,d0                        ; Handle keyDownEvent
        bne     MFHNotHandled

        cmp.w   #$41, EventType.data+keyDown.chr(a0)    ; handle 'A'
        beq     MenuAboutHandler
        cmp.w   #$61, EventType.data+keyDown.chr(a0)    ; handle 'a'
        beq     MenuAboutHandler
        cmp.w   #$43, EventType.data+keyDown.chr(a0)    ; handle 'C'
        beq     MenuClearHandler
        cmp.w   #$63, EventType.data+keyDown.chr(a0)    ; handle 'c'
        beq     MenuClearHandler
        bra     MFHNotHandled

MFHNotHandled
        clr.b   d0

MFHReturn
endproc

; *******************************************************************
; *                                                                 *
; *   Resources                                                     *
; *                                                                 *
; *   WBMP - Application Icon Bitmap resource.  Automatically       *
; *          converted from Windows format to Pilot format and      *
; *          written as a 'tAIB' rather than 'Tbmp' because kidbAIB *
; *          is a special value ($7ffe).                            *
; *   pref - Preference resource.  Defines app launch flags,        *
; *          stack and heap size.                                   *
; *   tFRM - Form resource.  Defined in scribble.rcp                *
; *   tver - Version resource                                       *                      *
; *   MBAR - Menu resource.  Defined in scribble.rcp                *
; *   Talt - Alert resource.  Defined in scribble.rcp               *
; *                                                                 *
; *   Filenames for scribble.rcp generated binaries are the         *
; *   resource type, followed by the ID in hexadecimal.             *
; *   E.g.  MBAR ID 1000 ==> mbar03e8.bin                           *
; *                                                                 *
; *******************************************************************

        res 'WBMP', kidbAIB, "Scribble.bmp"

        res 'pref', kidrPREF
        dc.w    sysAppLaunchFlagNewStack|sysAppLaunchFlagNewGlobals|sysAppLaunchFlagUIApp|sysAppLaunchFlagSubCall
        dc.l    $1000                   ; stack size
        dc.l    $1000                   ; heap size

        res 'tFRM', kidfMain, "tfrm03e8.bin"

        res 'tver', kidrTVER            
        dc.b    '1.0', 0

        res 'MBAR', kidmMain, "mbar03e8.bin"

        res 'Talt', kidrAboutAlert, "talt03e8.bin"

; ********************   debug code
;
; ********************     show hex representation of register in field
; ********************     "gpfieldEvent", only affecting a0 and d0
;        move.l  a2, -(a7)               ; put target as source operand
;        pea     strDisplay(a6)          ; push string address
;        trap    #15
;        dc.w    sysTrapStrIToH          ; convert x to hex
;        addq.l  #8, a7                  ; trash 2 entries off stack
;        systrap FldFreeMemory(gpfieldEvent(a5).l)
;        systrap FldInsert(gpfieldEvent(a5).l, &strDisplay(a6).l, #8.w)
;        systrap FldSetDirty (gpfieldEvent(a5).l, #0.b)
; ********************
;
;  these lines go at the beginning
;kidcEvent     equ           1005         ; define Event field control number
;global gpfieldEvent.12                   ; define Event field data storage
;
;  these lines go in frmLoadEvent handler
;                                        ; get event field pointer
;        systrap FrmGetObjectIndex(a3.l, #kidcEvent.w)
;        systrap FrmGetObjectPtr(a3.l,d0.w)
;        move.l  a0, gpfieldEvent(a5)    ; save Event Field Pointer
